﻿#Region "Imports"

Imports Infragistics.Controls.Schedules
Imports Infragistics.Controls
Imports Infragistics.Windows.Ribbon
Imports Infragistics.Controls.Schedules.Primitives
Imports System.Collections.ObjectModel
Imports Infragistics.Collections

#End Region

Public Class MyDialogHelper

  <ThreadStatic()> _
  Friend Shared _ignoreReminderComboSelectionChanged As Boolean

  Private _dataManager As XamScheduleDataManager = Nothing
  Private _activity As ActivityBase = Nothing
  Private _ribbonWindow As XamRibbonWindow

  Public Function CreateAppointmentDialog(container As FrameworkElement,
                                          dataManager As XamScheduleDataManager,
                                          activity As ActivityBase,
                                          allowModifications As Boolean,
                                          allowRemove As Boolean) As FrameworkElement
    Try
      _dataManager = dataManager
      _activity = activity
      _ribbonWindow = New XamRibbonWindow
      Dim adc = New MyAppointmentDialogCore(container,
                                            dataManager,
                                            activity,
                                            allowModifications,
                                            allowRemove)
      Dim rwch = New RibbonWindowContentHost
      _ribbonWindow.Content = rwch
      If Not IsNothing(activity.Subject) Then
        _ribbonWindow.Title = activity.Subject
      End If
      rwch.Content = adc

      rwch.Ribbon = GetInitializedRibbon(adc)

      Infragistics.CommandSourceManager.RegisterCommandTarget(adc)

      Dim binding As New Binding()
      binding.Mode = BindingMode.OneWay
      binding.Source = adc
      rwch.Ribbon.SetBinding(XamRibbon.DataContextProperty, binding)

      Return _ribbonWindow
    Catch ex As Exception
      Throw ex
    End Try
  End Function


  Private Function GetInitializedRibbon(adc As AppointmentDialogCore) As XamRibbon
    Try
      Dim isReminderToolRequired As Boolean = True
      Dim isRecurrenceToolRequired As Boolean = True
      Dim isTimeZoneToolRequired As Boolean = True
      Dim ribbon As New XamRibbon

      Dim tabItem = New RibbonTabItem()
      tabItem.Header = "Termin"
      ribbon.Tabs.Add(tabItem)

      '---> Gruppe Aktionen
      Dim ribbonGroup As New RibbonGroup()
      ribbonGroup.Caption = "Aktionen"
      tabItem.RibbonGroups.Add(ribbonGroup)

      '---> Button Speichern und Schliessen
      Dim buttonTool As New ButtonTool()
      buttonTool.Caption = "Speichern & schliessen"
      buttonTool.SetValue(ribbonGroup.MinimumSizeProperty, RibbonToolSizingMode.ImageAndTextLarge)
      buttonTool.SetValue(ribbonGroup.MaximumSizeProperty, RibbonToolSizingMode.ImageAndTextLarge)
      Dim commandSource As New ActivityDialogCoreCommandSource()
      commandSource.EventName = "Click"
      commandSource.CommandType = ActivityDialogCoreCommand.SaveAndClose
      commandSource.Parameter = adc
      buttonTool.SetValue(Commanding.CommandProperty, commandSource)
      ribbonGroup.Items.Add(buttonTool)

      '---> Button Löschen
      buttonTool = New ButtonTool()
      buttonTool.Caption = "Löschen"
      buttonTool.SetValue(ribbonGroup.MinimumSizeProperty, RibbonToolSizingMode.ImageAndTextLarge)
      buttonTool.SetValue(ribbonGroup.MaximumSizeProperty, RibbonToolSizingMode.ImageAndTextLarge)
      commandSource = New ActivityDialogCoreCommandSource()
      commandSource.EventName = "Click"
      commandSource.CommandType = ActivityDialogCoreCommand.Delete
      commandSource.Parameter = adc
      buttonTool.SetValue(Commanding.CommandProperty, commandSource)
      ribbonGroup.Items.Add(buttonTool)

      '...
      'reduced
      '...

      ribbonGroup = New RibbonGroup()
      ribbonGroup.Caption = "Kategorien"
      tabItem.RibbonGroups.Add(ribbonGroup)

      '---> Button  Kategorien
      Dim menuTool As New ButtonTool()
      menuTool.Caption = "Kategorisieren"
      menuTool.SetValue(ribbonGroup.MinimumSizeProperty, RibbonToolSizingMode.ImageAndTextLarge)
      menuTool.SetValue(ribbonGroup.MaximumSizeProperty, RibbonToolSizingMode.ImageAndTextLarge)
      '***
      '---> Problem: How can I create the category menu?
      '***

      ribbonGroup.Items.Add(menuTool)


      Return ribbon
    Catch ex As Exception
      Throw ex
    End Try
  End Function

End Class



